## SignonAuthService

SignonAuthService — The authorization service object

## Functions

void | (*SignonQueryMechanismCb) ()
void | (*SignonQueryMethodsCb) ()
SignonAuthService * | signon_auth_service_new ()
void | signon_auth_service_query_mechanisms ()
void | signon_auth_service_query_methods ()

## Types and Values

struct | SignonAuthService

## Object Hierarchy

        GObject
        ╰── SignonAuthService

## Description

The SignonAuthService is the main object in this library.

## Functions

### SignonQueryMechanismCb ()

    void
    (*SignonQueryMechanismCb) (SignonAuthService *auth_service,
                               const gchar *method,
                               gchar **mechanisms,
                               const GError *error,
                               gpointer user_data);

Callback to be passed to `signon_auth_service_query_mechanisms()`.

#### Parameters

auth_service | the SignonAuthService. |
method | the authentication method being inspected. |
mechanisms | list of available mechanisms. | [transfer none][type GStrv]
error | a GError if an error occurred, `NULL` otherwise. |
user_data | the user data that was passed when installing this callback. |

### SignonQueryMethodsCb ()

    void
    (*SignonQueryMethodsCb) (SignonAuthService *auth_service,
                             gchar **methods,
                             const GError *error,
                             gpointer user_data);

Callback to be passed to `signon_auth_service_query_methods()`.

#### Parameters

auth_service | the SignonAuthService. |
methods | list of available methods. | [transfer none][type GStrv]
error | a GError if an error occurred, `NULL` otherwise. |
user_data | the user data that was passed when installing this callback. |

### signon_auth_service_new ()

    SignonAuthService *
    signon_auth_service_new ();

Create a new SignonAuthService.

#### Returns

an instance of an SignonAuthService.

### signon_auth_service_query_mechanisms ()

    void
    signon_auth_service_query_mechanisms (SignonAuthService *auth_service,
                                          const gchar *method,
                                          SignonQueryMechanismCb cb,
                                          gpointer user_data);

Lists all the available mechanisms.

#### Parameters

auth_service | the SignonAuthService. |
method | the name of the method whose mechanisms must be retrieved. |
cb | callback to be invoked. | [scope async]
user_data | user data. |

### signon_auth_service_query_methods ()

    void
    signon_auth_service_query_methods (SignonAuthService *auth_service,
                                       SignonQueryMethodsCb cb,
                                       gpointer user_data);

Lists all the available methods.

#### Parameters

auth_service | the SignonAuthService. |
cb | callback to be invoked. | [scope async]
user_data | user data. |

## Types and Values

### struct SignonAuthService

    struct SignonAuthService;

Opaque struct. Use the accessor functions below.